#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n;
vector<int> f;

int readAns(InStream& stream){
    vector<string> codes;
    int expected_length = 0;
    for (int i=0; i<n; i++){
        
        // ensure code contains only dashes and dots
        string code = stream.readLine("[.-]+", "morse code");
        codes.push_back(code);
        
        // ensure code is not too large, otherwise prefix check is too slow
        stream.quitif(n < (int)code.size(), _wa, "team answer is not optimal, contains a very long code");
        
        // ensure code is not a prefix of other codes or viceversa
        for (int j=0; j<i; j++){
            stream.quitif(equal(
                code.begin(),
                code.begin() + min(code.size(), codes[j].size()),
                codes[j].begin()
            ), _wa, "invalid assignment, codes %i (%s) and %i (%s) are incompatible", j, codes[j].c_str(), i, code.c_str());
        }
        
        // add to expected length
        for (char c : code){
            expected_length += ((c=='-') ? 2 : 1) * f[i];
        }
    }
    
    return expected_length;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    
    // read testcase
    n = inf.readInt(2, 200, "n");
    f = vector<int>(n);
    vector<double> f_raw = inf.readDoubles(n, 0, 1, "frequencies");
    for (int i=0;i<n;i++)
        f[i] = round(10000*f_raw[i]);
    
    // read and check answers
    int judge_answer = readAns(ans);
    int team_answer = readAns(ouf);
    
    // compare answers
    if (judge_answer < team_answer)
        quit(_wa, "team answer is not optimal, judge solution is smaller");
    else if (judge_answer == team_answer)
        quitf(_ok, "answer is correct: %i", judge_answer);
    else
        quit(_fail, "judge answer is not optimal");
}
