#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

const string NESW = "URDL";
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};
const int MAXT = 10'000'000;
 
pair<int, int> readAndCheckAnswer(InStream &in, vector<string> board) {
  int n = board.size() - 2;
  int m = board[0].size() - 2;

  string result = in.readToken("YES|NO", "answer");
  if (result == "NO") return {-1, -1};

  int z = find(NESW.begin(), NESW.end(), in.readToken("[URDL]", "direction")[0]) - NESW.begin();
  int last_qt = 0;
  int q = in.readInt(0, n * m, "k");
  vector<int> qt(q), qx(q), qy(q);
  for (int i = 0; i < q; ++i) {
    qt[i] = in.readInt(last_qt, MAXT, "t_i");
    qx[i] = in.readInt(1, n, "r_i");
    qy[i] = in.readInt(1, m, "c_i");
    last_qt = qt[i];
  }

  int x = -1, y = -1;
  for (int i = 1; i <= n; ++i) {
    for (int j = 1; j <= m; ++j) {
      if (board[i][j] == 'S') {
        x = i; 
        y = j;
        board[i][j] = '.';
      }
    }
  }

  auto go = [&](int x, int y, int z, int& nx, int& ny, int& nz) {
    if (board[x][y] == '/') z ^= 1;
    if (board[x][y] == '\\') z ^= 3;
    nx = x + dx[z]; ny = y + dy[z]; nz = z;
    if (board[nx][ny] == '#') 
      nx = x, ny = y, nz = (z ^ 2);
  };

  int lim = last_qt + 4 * n * m + 10;
  int qptr = 0;
  for (int t = 1; t <= lim; ++t) {
    int nx, ny, nz; 
    go(x, y, z, nx, ny, nz);
    x = nx; y = ny; z = nz;
    if (x == 0 || y == 0 || x == n + 1 || y == m + 1) 
      return make_pair(q, t);
    while (qptr < q && qt[qptr] == t) {
      char& c = board[qx[qptr]][qy[qptr]];
      if (c != '/' && c != '\\')
        in.quitf(_wa, "Invalid operation [%d]", qptr + 1);
      c = '.';
      ++qptr;
    }
  }

  in.quitf(_wa, "Ball did not escape.");
}
 
int main(int argc, char *argv[]) {
  registerTestlibCmd(argc, argv);
  
  int n = inf.readInt(); 
  int m = inf.readInt();
  vector<string> board(n + 2);
  board[0] = board[n + 1] = string(m + 2, '.');
  for (int i = 1; i <= n; ++i) {
    board[i] = inf.readToken("[#\\.S\\\\/]+");
    board[i] = "." + board[i] + ".";
  }
 
  auto [ja, jt] = readAndCheckAnswer(ans, board);
  auto [pa, pt] = readAndCheckAnswer(ouf, board);

  if (ja != -1 && pa == -1) 
    quitf(_wa, "Jury has answer but participant has not");
  if (ja == -1 && pa != -1) 
    quitf(_fail, "Participant has answer but jury has not");
  if (ja < pa) 
    quitf(_wa, "Participant has sub-optimal answer");
  if (ja > pa) 
    quitf(_fail, "Jury has sub-optimal answer");

  quitf(_ok, "n=%d m=%d ans=%d time=%d", n, m, pa, pt);
}
