#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n;
vector<string> s;
string t;



int readAns(InStream& stream) {
    string result = stream.readToken("YES|NO", "result");
    if (result == "NO")
        return false;
    
    const int MAX_LEN = 1'000'000;
    string ans = stream.readToken("[a-z]{1," + to_string(MAX_LEN) + "}", "ans");
    ans = "_" + ans; // for convenience of implementation
    int len = ssize(ans);
    vector<vector<int>> jumpto(len, vector<int>(26, len));
    for (int i = len-2; i >= 0; i--) {
        jumpto[i] = jumpto[i+1];
        jumpto[i][ans[i+1] - 'a'] = i+1;
    }
    
    auto is_subseq = [&](string x) {
        int it = 0;
        for (char c: x) {
            it = jumpto[it][c-'a'];
            if (it == len) return false;
        }
        return true;
    };
    
    for (int i = 0; i < n; i++) {
        if (!is_subseq(s[i]))
            stream.quitf(_wa, "s[%d] is not a subsequence of the answer.", i);
    }
    
    if (is_subseq(t))
        stream.quit(_wa, "t is a subsequence of the answer.");
    return true;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
    s.resize(n);
    for (int i = 0; i < n; i++) s[i] = inf.readToken("[a-z]+", "s[i]");
    t = inf.readToken("[a-z]+", "t");

    bool jury_ans = readAns(ans);
    bool participant_ans = readAns(ouf);
    
    if (!participant_ans and jury_ans)
        quit(_wa, "The participant says NO, but the jury finds a solution.");
    else if (participant_ans == jury_ans)
        quit(_ok, "Participant and jury agree.");
    else
        quitf(_fail, "The jury says NO, but the participant find a solution.");
}
