#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
#define SZ(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()

// Returns the time elapsed in nanoseconds from 1 January 1970, at 00:00:00.
LL get_time() {
    return chrono::duration_cast<chrono::nanoseconds>(
        chrono::steady_clock::now().time_since_epoch())
        .count();
}

// Returns a random integer from the range [l, r].
LL randint(LL l, LL r) {
	#if LOCAL && !ONLINE_JUDGE
	static mt19937_64 gen; // Deterministic on the local machine.
	#else
	static mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
	#endif
	return uniform_int_distribution<LL>(l, r)(gen);
}

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f = nullptr);

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p);

#define _define_print_container(Container, bef, aft)        \
template <typename T>                                       \
ostream& operator <<(ostream& out, const Container<T>& v) { \
    out << print_iterable(v.begin(), v.end(), bef, aft);    \
    return out;                                             \
}                                                           \

_define_print_container(vector, "[", "]");
_define_print_container(set, "{", "}");
_define_print_container(unordered_set, "{", "}");
_define_print_container(multiset, "{", "}");
_define_print_container(unordered_multiset, "{", "}");
_define_print_container(deque, "[", "]");

#define _define_print_dictionary(Dictionary, bef, aft)                      \
template <typename T1, typename T2>                                         \
ostream& operator <<(ostream& out, const Dictionary<T1, T2>& v) {           \
    out << print_iterable(v.begin(), v.end(), bef, aft);                    \
    return out;                                                             \
}                                                                           \

_define_print_dictionary(map, "{", "}");
_define_print_dictionary(unordered_map, "{", "}");

#define _define_print_container_adaptor(Adaptor, OP)                        \
template <typename T>                                                       \
ostream& operator <<(ostream& out, Adaptor<T> a) {                          \
    vector<T> v;                                                            \
    while (!a.empty()) v.push_back(a.OP()), a.pop();                        \
    out << v;                                                               \
    return out;                                                             \
}                                                                           \

_define_print_container_adaptor(stack, top)
_define_print_container_adaptor(queue, front)
_define_print_container_adaptor(priority_queue, top)

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f) {
    stringstream res;
    res << bef;
    bool is_first = true;
    for (Iterator it = begin; it != end; ++it) {
        if (!is_first) res << ", ";
        if (f != nullptr) res << (*f)(*it);
        else res << *it;
        is_first = false;
    }
    res << aft;
    return res.str();
}

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p) {
    out << "{" << p.first << ", " << p.second << "}";
    return out;
}

template<class TH>
void _dbg(const char* name, TH val){
    clog << name << ": " << val << endl;
}
template<class TH, class... TA>
void _dbg(const char* names, TH curr_val, TA... vals) {
    while(*names != ',') clog << *names++;
    clog << ": " << curr_val << ", ";
    _dbg(names+1, vals...);
}

#if LOCAL && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file

    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif

///////////////////////////////////////////////////////////////////////////
//////////////////// DO NOT TOUCH BEFORE THIS LINE ////////////////////////
///////////////////////////////////////////////////////////////////////////

const int MAX_SZ = 2025;
char ans[MAX_SZ][MAX_SZ];



LL binom(LL x) { return (x*(x-1))/2; }

void solve(LL k, LL h, LL w) {
    assert(w >= 4);
    LL a = binom(w-3) * binom(h);
    if (a > k) {
        solve(k, h, w-1);
        return;
    }
    
    for (int i = 0; i < h; i++) for (int j = 3; j < w; j++) ans[i][j] = '#';
    k -= a;
    
    //~ dbg(k, a);
    
    LL x = 0;
    LL y = w-3;
    while (k > 0) {
        assert(h >= 1);
        bool found = false;
        for (LL z = 3; z >= 1; z--) {
            LL a = binom(z)* x + z*x*y;
            if (a > k) continue;
            k -= a;
            for (int j = 2; j >= 3-z; j--) ans[h-1][j] = '#';
            found = true;
            //~ cout << z << " ";
            break;
        }
        x++;
        h--;
        if (!found) {
            cout << endl;
            //~ cout << "k: " << k << ", h: " << h << endl;
            x = 0; 
            if (k < y) break;
        }
    }
    //~ cout << "BREAK" << endl;
    
    // Now, we can only use 1 or 2.
    while (k > 0) {
        int q = 2;
        while (k >= binom(q+1)) q++;
        assert(h >= q);
        for (int i = 0; i < q; i++) {
            ans[h-1][0] = ans[h-1][1] = '#';
            h--;
        }
        k -= binom(q);
        //~ cout << "q: " << q << ", k: " << k << ", h: " << h << endl;
        h--;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); // Remove in problems with online queries!
    
    for (int i = 0; i < MAX_SZ; i++)
        for (int j = 0; j < MAX_SZ; j++)
            ans[i][j] = '.';

    LL k;
    cin >> k;
    solve(k, MAX_SZ, MAX_SZ);
    
    
    //~ LL maxk = binom(MAX_SZ) * binom(MAX_SZ);
    //~ LL prev_maxk = binom(MAX_SZ-1) * binom(MAX_SZ-1);
    //~ cout << "Max k = " << maxk << endl;
    //~ cout << "(previous max k = " << prev_maxk << ")" << endl;
    
    
    //~ LL k = 2'500'000;
    
    //~ LL k0 = 4.195e12;
    //~ LL coef = 5;
    //~ for (LL _ = 0; _ < 100000; _++) {
        //~ if (k % 1000 == 0) cout << k << endl;
        //~ LL k = randint(prev_maxk, (prev_maxk + coef*maxk)/(1+coef));
        //~ LL k = 4198133983759;
        //~ cout << k << endl;
        //~ solve(k, MAX_SZ, MAX_SZ, false);
    //~ }
    
    cout << MAX_SZ << " " << MAX_SZ << "\n";
    for (int i = 0; i < MAX_SZ; i++) {
        for (int j = 0; j < MAX_SZ; j++) cout << ans[i][j];
        cout << endl;
    }
    
}
