#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>

struct splitmix64_hash {
	static uint64_t splitmix64(uint64_t x) {
		// http://xorshift.di.unimi.it/splitmix64.c
		x += 0x9e3779b97f4a7c15;
		x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
		x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
		return x ^ (x >> 31);
	}

	size_t operator()(uint64_t x) const {
		static const uint64_t FIXED_RANDOM = std::chrono::steady_clock::now().time_since_epoch().count();
		return splitmix64(x + FIXED_RANDOM);
	}
};

template <typename K, typename V, typename Hash = splitmix64_hash>
using hash_map = __gnu_pbds::gp_hash_table<K, V, Hash>;

template <typename K, typename Hash = splitmix64_hash>
using hash_set = hash_map<K, __gnu_pbds::null_type, Hash>;

namespace std {

template<class Fun>
class y_combinator_result {
	Fun fun_;
public:
	template<class T>
	explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

	template<class ...Args>
	decltype(auto) operator()(Args &&...args) {
		return fun_(std::ref(*this), std::forward<Args>(args)...);
	}
};

template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
	return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}

} // namespace std

using ll = int64_t;

void solve(){
	mt19937 mt(48);
	int N;
	cin >> N;
	vector<ll> A(N);
	for(int i = 0; i < N; i++) cin >> A[i];

	vector<pair<ll, int> > cands_list;
	for(int i = 0; i < N; i++){
		for(int d = 1; d <= N; d++) cands_list.push_back({A[i] * d, i});
	}
	sort(cands_list.begin(), cands_list.end());
	cerr << "sorted" << '\n';
	vector<ll> cand_values;
	vector<vector<int> > cand_adj;
	{
		int idx = 0;
		while(idx < (int)cands_list.size()){
			ll x = cands_list[idx].first;
			cand_values.push_back(x);
			vector<int> adj;
			while(idx < (int)cands_list.size() && cands_list[idx].first == x){
				adj.push_back(cands_list[idx].second);
				idx++;
			}
			shuffle(adj.begin(), adj.end(), mt);
			cand_adj.push_back(adj);
		}
	}
	vector<ll> match(N, -1);
	int cnt = 0;
	ll cur_time = 0;

	vector<int> vis(N, 0);
	for(int cand_idx = 0; cand_idx < (int)cand_adj.size(); cand_idx++){
		if(cnt == N) break;
		cur_time = cand_values[cand_idx];

		for(int idx : cand_adj[cand_idx]){
			if(vis[idx]) continue;
			vector<int> all_vis;
			bool ok = y_combinator([&](auto self, int v) -> bool {
				if(match[v] == -1) return 1;
				ll z = match[v];
				all_vis.push_back(v);
				vis[v] = 1;
				for(int r : cand_adj[z]){
					if(!vis[r] && self(r)){
						match[r] = z;
						return 1;
					}
				}
				return 0;
			})(idx);
			if(ok){
				cnt++;
				match[idx] = cand_idx;
				for(int f : all_vis) vis[f] = 0;
				break;
			}
		}
	}
	assert(cnt == N);
	cout << cur_time << '\n';
}

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int T;
	cin >> T;
	while(T--) solve();
}
