#include <bits/stdc++.h>
using namespace std;

namespace std {

template<class Fun>
class y_combinator_result {
	Fun fun_;
public:
	template<class T>
	explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

	template<class ...Args>
	decltype(auto) operator()(Args &&...args) {
		return fun_(std::ref(*this), std::forward<Args>(args)...);
	}
};

template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
	return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}

} // namespace std

using ll = int64_t;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N;
	cin >> N;
	vector<int> val(N);
	for(int i = 0; i < N; i++){
		double prob;
		cin >> prob;
		val[i] = int((prob * 10000) + 0.5);
	}

	vector<int> ord(N);
	for(int i = 0; i < N; i++) ord[i] = i;
	sort(ord.begin(), ord.end(), [&](int i, int j){
		return val[i] > val[j];
	});

	vector<int> A(N);
	for(int i = 0; i < N; i++) A[i] = val[ord[i]];
	vector<ll> suff(N+1, 0);
	for(int i = N-1; i >= 0; i--) suff[i] = suff[i+1] + A[i];
	// minimize sum A[i] * len

	ll INF = 1e18;
	vector<vector<vector<ll> > > dp(N+1, vector<vector<ll> >(N+1, vector<ll>(N+1, INF)));
	vector<vector<vector<int> > > where(N+1, vector<vector<int> >(N+1, vector<int>(N+1, 0)));
	for(int j = 0; j <= N; j++){
		for(int k = 0; k <= N; k++){
			dp[N][j][k] = 0;
		}
	}
	for(int idx = N-1; idx >= 0; idx--){
		for(int a = N; a >= 0; a--){
			for(int b = N; b >= 0; b--){
				if(a > 0){
					if(dp[idx+1][a-1][b] < dp[idx][a][b]){
						dp[idx][a][b] = dp[idx+1][a-1][b];
						where[idx][a][b] = 1;
					}
				}
				if(a < N){
					ll ndp = dp[idx][min(N, a+b)][a] + suff[idx];
					if(ndp < dp[idx][a][b]){
						dp[idx][a][b] = ndp;
						where[idx][a][b] = 2;
					}
				}
			}
		}
	}
	vector<int> wgt(N);
	int cidx = 0, ca = 1, cb = 1;
	int cur = 1;
	while(cidx < N){
		if(where[cidx][ca][cb] == 1){
			wgt[cidx] = cur;
			cidx++;
			ca--;
		} else if(where[cidx][ca][cb] == 2){
			cur += 1;
			swap(ca, cb);
			ca += cb;
			ca = min(ca, N);
		} else {
			assert(false);
		}
	}
	map<int, vector<string> > use;
	use[0].push_back("");
	cidx = 0;

	vector<string> codes(N);
	for(int l = 0; ; l++){
		while(cidx < N && wgt[cidx] == l){
			codes[ord[cidx]] = use[l].back();
			use[l].pop_back();
			cidx++;
		}
		if(cidx == N) break;
		while(!use[l].empty()){
			use[l+1].push_back(use[l].back() + '.');
			use[l+2].push_back(use[l].back() + '-');
			use[l].pop_back();
		}
	}
	for(int i = 0; i < N; i++){
		cout << codes[i] << '\n';
	}
}

