#include <bits/stdc++.h>
using namespace std;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N, M;
	cin >> N >> M;
	vector<string> grid_unpad(N);
	for(int i = 0; i < N; i++){
		cin >> grid_unpad[i];
	}
	vector<string> grid(N+2, string(M+2, '.'));
	for(int i = 0; i < N; i++){
		for(int j = 0; j < M; j++){
			grid[i+1][j+1] = grid_unpad[i][j];
		}
	}
	pair<int,int> st;
	for(int i = 0; i < N+2; i++){
		for(int j = 0; j < M+2; j++){
			if(grid[i][j] == 'S'){
				st = {i, j};
				grid[i][j] = '.';
			}
		}
	}
	vector<int> dx = {0, 1, 0, -1};
	vector<int> dy = {1, 0, -1, 0};

	auto get_id = [&](pair<pair<int,int>, int> p){
		return p.second + 4 * (p.first.second + (M+2) * p.first.first);
	};
	auto get_coords = [&](int id) -> tuple<int,int,int> {
		return {id / 4 / (M+2), (id / 4) % (M+2), id % 4};
	};
	int V = (N+2) * (M+2) * 4;
	vector<vector<pair<int,int> > > adj(V);

	auto add_edge = [&](int v, int w, int wd){
		// adj[v].push_back({w, wd});
		adj[w].push_back({v, wd});
	};
	for(int x = 0; x < N+2; x++){
		for(int y = 0; y < M+2; y++){
			for(int d = 0; d < 4; d++){
				int nx = x + dx[d];
				int ny = y + dy[d];
				if(nx < 0 || nx >= N+2 || ny < 0 || ny >= M+2) continue;
				int v = get_id({{x,y}, d});
				if(grid[nx][ny] == '.'){
					add_edge(v, get_id({{nx,ny}, d}), 0);
				} else if(grid[nx][ny] == '#'){
					add_edge(v, get_id({{nx,ny}, (d+2)%4}), 0);
				} else if(grid[nx][ny] == '/'){
					add_edge(v, get_id({{nx,ny}, d^3}), 0);
					add_edge(v, get_id({{nx,ny}, d}), 1);
				} else if(grid[nx][ny] == '\\'){
					add_edge(v, get_id({{nx,ny}, d^1}), 0);
					add_edge(v, get_id({{nx,ny}, d}), 1);
				}
			}
		}
	}

	vector<pair<pair<int,int>, int> > srcs, dsts;
	for(int i = 1; i <= N; i++){
		dsts.push_back({{i, 0}, 0});
		dsts.push_back({{i, M+1}, 2});
	}
	for(int j = 1; j <= M; j++){
		dsts.push_back({{0, j}, 1});
		dsts.push_back({{N+1, j}, 3});
	}
	for(int dir = 0; dir < 4; dir++){
		srcs.push_back({st, dir});
	}

	using dist_t = pair<int,int>;

	int INF = 1e8;
	vector<dist_t> dist(V, {INF, 0});
	vector<int> par(V, -1);

	priority_queue<pair<dist_t,int>, vector<pair<dist_t,int> >, greater<pair<dist_t,int> > > pq;
	for(auto src : srcs){
		int v = get_id(src);
		dist[v] = {0, 0};
		pq.push({dist[v], v});
		par[v] = -2;
	}
	auto trav = [&](dist_t d, int wd) -> pair<int,int> {
		if(wd == 0) return {d.first, d.second + 1};
		return {d.first + wd, 0};
	};
	while(!pq.empty()){
		auto [d, v] = pq.top(); pq.pop();
		if(d > dist[v]) continue;
		for(auto [w, wd] : adj[v]){
			if(dist[w] > trav(d, wd)){
				dist[w] = trav(d, wd);
				pq.push({dist[w], w});
				par[w] = v;
			}
		}
	}
	string compass = "RDLU";
	int best_loc = -1;
	dist_t best_dist = {INF, 0};
	for(auto dst : dsts){
		int v = get_id(dst);
		if(dist[v] < best_dist){
			best_dist = dist[v];
			best_loc = v;
		}
	}
	if(best_dist.first >= INF){
		cout << "NO" << '\n';
		exit(0);
	}
	int cur = best_loc;
	vector<int> path_ids = {cur};
	while(par[cur] != -2){
		assert(par[cur] != -1);
		cur = par[cur];
		path_ids.push_back(cur);
	}
	reverse(path_ids.begin(), path_ids.end());
	cout << "YES" << '\n';
	cout << compass[get<2>(get_coords(path_ids.front())) ^ 2] << '\n';
	vector<tuple<int,int,int> > ops;

	int T = 0;
	for(int i = 0; i + 1 < (int)path_ids.size(); i++){
		int d = dist[path_ids[i+1]].first - dist[path_ids[i]].first;
		auto [x, y, dir] = get_coords(path_ids[i]);
		if(d == 1){
			assert(grid[x][y] == '/' || grid[x][y] == '\\');
			ops.push_back({T, x, y});
		}
		if(grid[x][y] == '#'){
			T += 0;
		} else {
			T += 1;
		}
	}
	cout << ops.size() << '\n';
	for(auto [t, x, y] : ops){
		cout << t << ' ' << x << ' ' << y << '\n';
	}
}

