#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
#define SZ(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()

// Returns the time elapsed in nanoseconds from 1 January 1970, at 00:00:00.
LL get_time() {
    return chrono::duration_cast<chrono::nanoseconds>(
        chrono::steady_clock::now().time_since_epoch())
        .count();
}

// Returns a random integer from the range [l, r].
LL randint(LL l, LL r) {
	#if LOCAL && !ONLINE_JUDGE
	static mt19937_64 gen; // Deterministic on the local machine.
	#else
	static mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
	#endif
	return uniform_int_distribution<LL>(l, r)(gen);
}

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f = nullptr);

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p);

#define _define_print_container(Container, bef, aft)        \
template <typename T>                                       \
ostream& operator <<(ostream& out, const Container<T>& v) { \
    out << print_iterable(v.begin(), v.end(), bef, aft);    \
    return out;                                             \
}                                                           \

_define_print_container(vector, "[", "]");
_define_print_container(set, "{", "}");
_define_print_container(unordered_set, "{", "}");
_define_print_container(multiset, "{", "}");
_define_print_container(unordered_multiset, "{", "}");
_define_print_container(deque, "[", "]");

#define _define_print_dictionary(Dictionary, bef, aft)                      \
template <typename T1, typename T2>                                         \
ostream& operator <<(ostream& out, const Dictionary<T1, T2>& v) {           \
    out << print_iterable(v.begin(), v.end(), bef, aft);                    \
    return out;                                                             \
}                                                                           \

_define_print_dictionary(map, "{", "}");
_define_print_dictionary(unordered_map, "{", "}");

#define _define_print_container_adaptor(Adaptor, OP)                        \
template <typename T>                                                       \
ostream& operator <<(ostream& out, Adaptor<T> a) {                          \
    vector<T> v;                                                            \
    while (!a.empty()) v.push_back(a.OP()), a.pop();                        \
    out << v;                                                               \
    return out;                                                             \
}                                                                           \

_define_print_container_adaptor(stack, top)
_define_print_container_adaptor(queue, front)
_define_print_container_adaptor(priority_queue, top)

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f) {
    stringstream res;
    res << bef;
    bool is_first = true;
    for (Iterator it = begin; it != end; ++it) {
        if (!is_first) res << ", ";
        if (f != nullptr) res << (*f)(*it);
        else res << *it;
        is_first = false;
    }
    res << aft;
    return res.str();
}

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p) {
    out << "{" << p.first << ", " << p.second << "}";
    return out;
}

template<class TH>
void _dbg(const char* name, TH val){
    clog << name << ": " << val << endl;
}
template<class TH, class... TA>
void _dbg(const char* names, TH curr_val, TA... vals) {
    while(*names != ',') clog << *names++;
    clog << ": " << curr_val << ", ";
    _dbg(names+1, vals...);
}

#if LOCAL && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file

    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif

///////////////////////////////////////////////////////////////////////////
//////////////////// DO NOT TOUCH BEFORE THIS LINE ////////////////////////
///////////////////////////////////////////////////////////////////////////

const int MAXN = 205;

int n;
vector<int> f;
vector<int> ord;
int presum[MAXN];
string ans[MAXN];
int memo[MAXN][MAXN][MAXN];
int cnt = 0;
// a zeroes, b ones
int solve(int m, int a, int b) {
    if (m == 0) return 0;
    if (a + b == 0) return 1e9;
    if (a + b > m) return 1e9;
    if (a == 0) return presum[m] + solve(m, b, 0);
    if (memo[m][a][b]) return memo[m][a][b];
    cnt++;
    
    memo[m][a][b] = min(solve(m-1, a-1, b), presum[m] + solve(m, a + b, a));
    return memo[m][a][b];
}

void reconstruct(int m, int a, int b, vector<string> s) {
    if (m == 0) return;
    if (a == 0) {
        reconstruct(m, b, 0, s);
        return;
    }
    if (solve(m, a, b) == solve(m-1, a-1, b)) {
        ans[ord[m-1]] = s[0];
        s.erase(s.begin());
        reconstruct(m-1, a-1, b, s);
        return;
    }
    vector<string> new_s;
    for (int i = 0; i < a; i++) {
        s.push_back(s[0] + ".");
        new_s.push_back(s[0] + "-");
        s.erase(s.begin());
    }
    for (string t: new_s) s.push_back(t);
    reconstruct(m, a+b, a, s);
}

int main() {
    cin >> n;
    f.resize(n);
    for (int i = 0; i < n; i++) {
        double x;
        cin >> x;
        f[i] = round(x*10000);
    }
    ord.resize(n);
    for (int i = 0; i < n; i++) ord[i] = i;
    sort(all(ord), [&](int i, int j) { return f[i] < f[j]; });
    
    sort(all(f));
    
    for (int i = 0; i < n; i++) presum[i+1] = f[i] + presum[i];
    
    solve(n, 1, 0);
    reconstruct(n, 1, 0, {""});
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
        
    //~ cout << cnt << endl;
}
