#include <bits/stdc++.h>

using namespace std;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};
const int INF = 2e9;

int main() {
  int n, m; cin >> n >> m;
  vector<string> v(n + 2);
  v[0] = v[n + 1] = string(m + 2, '.');
  for (int i = 1; i <= n; ++i) {
    cin >> v[i];
    v[i] = "." + v[i] + ".";
  }
  n += 2; m += 2;
  
  int sx = -1, sy = -1;
  for (int i = 0; i < n; ++i) 
    for (int j = 0; j < m; ++j) 
      if (v[i][j] == 'S') 
        sx = i, sy = j, v[i][j] = '.';

  auto go = [&](int x, int y, int z, char c, int& nx, int& ny, int& nz) {
    if (c == '/') z ^= 1;
    if (c == '\\') z ^= 3;
    nx = x + dx[z]; ny = y + dy[z]; nz = z;
    if (v[nx][ny] == '#') 
      nx = x, ny = y, nz = (z ^ 2);
  };

  vector<vector<array<int, 4>>> dist(n, vector<array<int, 4>>(m, {INF, INF, INF, INF}));
  priority_queue<tuple<int, int, int, int>> pq;
  auto push = [&](int x, int y, int z, int d) {
    if (v[x][y] == '#' || dist[x][y][z] <= d) 
      return;
    dist[x][y][z] = d;
    pq.emplace(-d, x, y, z);
  };

  for (int sz = 0; sz < 4; ++sz)
    push(sx, sy, sz, 0);
  while (!pq.empty()) {
    auto [d, x, y, z] = pq.top(); pq.pop(); d = -d;
    if (d != dist[x][y][z]) continue;
    if (x == 0 || y == 0 || x == n - 1 || y == m - 1) {
      // Simulate
      int tm = 0; z = (z ^ 2); char c = '.'; 
      vector<tuple<int, int, int>> ans;
      int d2 = d;
      while (x != sx || y != sy) {
        assert(x >= 0 && y >= 0 && x < n && y < m);
        int nx, ny, nz; 
        ++tm;

        // for (int i = 0; i < n; ++i) {
        //   for (int j = 0; j < m; ++j) {
        //     if (i == x && j == y) cerr << "URDL"[z];
        //     else cerr << v[i][j];
        //   }
        //   cerr << endl;
        // }
        // cerr << x << " " << y << " " << z << " " << dist[x][y][z ^ 2] << endl;
        if ((v[x][y] == '\\' || v[x][y] == '/') && 
            (dist[x][y][z ^ 2] == (d - ans.size() - 1))) {
          go(x, y, z, '.', nx, ny, nz); 
          // cerr << "remove\n";
          ans.emplace_back(tm, x, y);
        } else {
          go(x, y, z, v[x][y], nx, ny, nz); 
        }
        x = nx; y = ny; z = nz;
      }
      reverse(ans.begin(), ans.end());
      // cerr << ans.size() << " " << d << endl;
      assert(ans.size() == d);

      cout << "YES\n";
      cout << "URDL"[z ^ 2] << '\n';
      cout << ans.size() << '\n';
      for (auto [t, x, y] : ans) 
        cout << tm - t + 1 << " " << x << " " << y << '\n';
      return 0;
    }
    int nx, ny, nz, nd = d;
    go(x, y, z, v[x][y], nx, ny, nz);
    push(nx, ny, nz, nd);
    if (v[x][y] == '/' || v[x][y] == '\\') {
      go(x, y, z, '.', nx, ny, nz);
      push(nx, ny, nz, nd + 1);
    }
  }

  cout << "NO\n";

  // for (int i = 0; i < n; ++i) {
  //   for (int j = 0; j < m; ++j) {
  //     int ans = -1;
  //     for (int z = 0; z < 4; ++z) {
  //       if (dist[i][j][z] == -1) continue;
  //       if (ans == -1 || ans > dist[i][j][z]) ans = dist[i][j][z];
  //     }
  //     if (ans == -1) cout << "-";
  //     else cout << ans;
  //   }
  //   cout << " " << v[i] << endl;
  // }

  return 0;
}
