#include <bits/stdc++.h>

using namespace std;
typedef pair<int, int> pii;
#define S second
#define F first
#define MAXN 200005

vector<vector<int>> adj;
int f[MAXN], g[MAXN];
int n, m, s, t;
int vis[MAXN], dis[MAXN];
int bedge[MAXN];
set<pii>* alt[MAXN];

const int INF = 1e9;

int par[MAXN], rnk[MAXN];

void init(int N){ for(int i = 0; i < N; i ++) par[i] = i, rnk[i] = 0; }
int find(int i){ return ((par[i] == i) ? i : (par[i] = find(par[i]))); }
void merge(int i, int j) {
  if (find(i) != find(j)) {
    int x = find(i), y = find(j);
    if (rnk[x] > rnk[y]) par[y] = x;
    else {
      par[x] = y;
      if (rnk[x] == rnk[y]) rnk[y]++;
    }
  }
}

void bfs(int st) {
  queue<pii> q;
  q.push(pii(0, st));
  vis[st] = 1;
  while (!q.empty()) {
    pii nx = q.front();
    q.pop();
    dis[nx.S] = nx.F;

    for (int v : adj[nx.S]) {
      if (vis[v]) continue;
      vis[v] = 1;
      q.push(pii(nx.F + 1, v));
    }
  }
}

void mergeSets(int v, int& modv, int u, int& modu) {
  if (alt[v]->size() >= alt[u]->size()) {
    int diff = modu - modv;
    for (pii p : *alt[u])
      alt[v]->insert(pii(p.first + diff, p.second));
    modu = modv;
    alt[u] = alt[v];
  }
  else
    mergeSets(u, modu, v, modv);
}

int calc_g(int v) {
  if (vis[v]) {
    fprintf(stderr, "%d %d\n", v, bedge[v]);
    assert(false);
    return INF;
  }
  vis[v] = 1;

  for (int u : adj[v]) {
    if (bedge[u] != v && bedge[v] != u) {
      alt[v]->insert(pii(1 + dis[u], u));
    }
  }

  int modv = 0;
  for (int u : adj[v])
    if (bedge[u] == v) {
      int modu = calc_g(u) + 1;
      mergeSets(v, modv, u, modu);
      //      for (pii p : alt[u])
      //	alt[v].insert(pii(p.first + 1, p.second));
      merge(v, u);
    }

  while (alt[v]->size() && find(alt[v]->begin()->second) == find(v)) {
    alt[v]->erase(alt[v]->begin());
  }

  if (alt[v]->size())
    g[v] = alt[v]->begin()->first + modv;
  return modv;
}

void calc_g() {
  for (int i = 0; i < n; i++) {
    g[i] = INF;
    vis[i] = 0;
    alt[i] = new set<pii>();
    bedge[i] = -1;
  }
  init(n);  
  bfs(t);

  for (int i = 0; i < n; i++)
    vis[i] = 0;
  
  for (int v = 0; v < n; v++)
    for (int u : adj[v])
      if (dis[v] == dis[u] + 1) {
	bedge[v] = u;
	break;
      }

  calc_g(t);
}

void calc_f() {
  for (int i = 0; i < n; i++) {
    f[i] = INF;
    vis[i] = 0;
  }

  std::priority_queue<pii, std::vector<pii>, std::greater<pii>> pq;
  pq.push(pii(0, t));
  while (!pq.empty()) {
    pii nx = pq.top();
    pq.pop();

    if (vis[nx.S])
      continue;
    vis[nx.S] = 1;

    if (nx.S != t) {
      f[nx.S] = INF;
      for (int v : adj[nx.S])
	f[nx.S] = min(f[nx.S], 1 + f[v]);
      f[nx.S] = max(f[nx.S], g[nx.S]);
    }
    else
      f[nx.S] = 0;

    for (int v : adj[nx.S])
      pq.push(pii(f[nx.S], v));

    if (nx.S == s)
      return;
  }
}

int calc_ans() {
  calc_g();
  calc_f();
  return f[s];
}

int main() {
  // Read input
  cin >> n >> m;
  s = 0;
  t = n - 1;
    
  adj.assign(n + 1, vector<int>());
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    u--; v--;
    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  int result = calc_ans();
  if (result < INF)
    cout << result << endl;
  else
    cout << -1 << endl;

  //for (int i = 0; i < n; i++)
    //cout << i << ": " << g[i] << endl;

  return 0;
}

