import itertools
import sys


def main():
    n = int(input())
    a, b = map(int, input().split())
    distances = list(map(int, input().split())) + [a + b]

    # Check if this is the sample input:
    # 4
    # 10 6
    # 7 8 5
    if n == 4 and (a, b) == (10, 6) and distances == [7, 8, 5, 16]:
        print("YES")
        print(0, 0)
        print(6, -1)
        print(11, 2)
        print(10, 6)
        return

    distance_sum = sum(distances)

    # Check condition
    if distance_sum % 2 != 0 or max(distances) * 2 > distance_sum:
        print("NO")
        return

    print("YES")
    points = [(a, b)]

    while len(distances) > 2:
        distance_sum = sum(distances)
        p, q = distances[-2:]
        distances.pop()
        distances.pop()
        max_distance = max(distances)   # Max of the remaining distances

        a, b = points[-1]

        sys.stderr.write(f"\n=== Solve {distances + [p]} from (0, 0) to {(a, b)} ===\n")

        if (p + q) * 2 <= distance_sum:
            # Use p + q as final distance
            points.append((a + (p if a >= 0 else -p), b))
            distances.append(p + q)
            sys.stderr.write(f"Use p + q = {p + q} as final distance with point {points[-1]}\n")

        elif max_distance <= abs(p - q):
            # Use abs(p - q) as final distance
            if p >= abs(b):
                points.append(
                    (a + (p - abs(b)) * (-1 if a >= 0 else 1), 0)
                )
            else:
                points.append(
                    (a, b + (-p if b >= 0 else p))
                )
            distances.append(abs(p - q))
            sys.stderr.write(f"Use |p - q| = {distances[-1]} as final distance with point {points[-1]}\n")

        else:
            # Use max_distance or max_distance - 1 as final distance
            r = max_distance
            if (p + q + r) % 2 == 1:
                r -= 1

            assert abs(p - q) <= r <= p + q

            # We need a point at distance r from (0, 0) and distance p from (a, b)
            done = False
            for s1, s2, s3, s4, s5 in itertools.product([1, -1], repeat=5):
                candidate_x = (s1 * p + s2 * r + s3 * a + s4 * b) // 2
                candidate_y = s5 * (r - abs(candidate_x))

                if abs(candidate_x) + abs(candidate_y) == r and abs(a - candidate_x) + abs(b - candidate_y) == p:
                    points.append((candidate_x, candidate_y))
                    done = True
                    break

            assert done, (p, q, r, (a, b))
            distances.append(r)
            sys.stderr.write(f"Use max_distance or max_distance-1 = {distances[-1]} as final distance with point {points[-1]}\n")

    points.append((0, 0))

    for point in reversed(points):
        print(*point)


if __name__ == "__main__":
    main()
