#include <bits/stdc++.h>
using namespace std;

namespace std {

template<class Fun>
class y_combinator_result {
	Fun fun_;
public:
	template<class T>
	explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

	template<class ...Args>
	decltype(auto) operator()(Args &&...args) {
		return fun_(std::ref(*this), std::forward<Args>(args)...);
	}
};

template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
	return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}

} // namespace std

using ll = int64_t;
int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N;
	cin >> N;
	ll X, Y;
	cin >> X >> Y;
	vector<ll> D(N-1);
	ll dsum = 0;
	for(int i = 0; i < N-1; i++){
		cin >> D[i];
		dsum += D[i];
	}
	auto fix = y_combinator([&](auto self, pair<ll, ll> p, pair<ll, ll> q, ll d1, ll d2) -> pair<ll, ll> {
		if(p.first > q.first){
			p.first *= -1;
			q.first *= -1;
			pair<ll, ll> ret = self(p, q, d1, d2);
			return {-ret.first, ret.second};
		}
		if(p.second > q.second){
			p.second *= -1;
			q.second *= -1;
			pair<ll, ll> ret = self(p, q, d1, d2);
			return {ret.first, -ret.second};
		}
		ll cd = (q.first - p.first) + (q.second - p.second);
		ll extra = (d1 + d2 - cd);
		assert(extra % 2 == 0);
		assert(extra >= 0);
		extra /= 2;
		if((d1 - extra) <= (q.first - p.first)){
			return {p.first + (d1 - extra), p.second - extra};
		} else {
			return {q.first + extra, q.second - (d2 - extra)};
		}
	});
	if(dsum < X + Y || (dsum - X - Y) % 2 != 0){
		cout << "NO" << '\n';
	} else {
		vector<pair<ll, ll> > pts;
		pts.push_back({0, 0});
		for(int i = 0; i < N-1; i++){
			ll max_left = 0;
			ll sum_left = 0;
			for(int j = i+1; j < N-1; j++){
				sum_left += D[j];
				max_left = max(max_left, D[j]);
			}
			ll cd = abs(X - pts.back().first) + abs(Y - pts.back().second);
			pair<ll, ll> c1 = {abs(cd - D[i]), cd + D[i]};
			pair<ll, ll> c2 = {2 * max_left - sum_left, sum_left};
			if(c1.second < c2.first || c2.second < c1.first){
				cout << "NO" << '\n';
				exit(0);
			}
			pair<ll, ll> p = fix(pts.back(), pair<ll, ll>{X, Y}, D[i], min(c1.second, c2.second));
			pts.push_back(p);
		}
		cout << "YES" << '\n';
		for(auto [x, y] : pts){
			cout << x << ' ' << y << '\n';
		}
	}
}
