#include <iostream>
#include <string>
#include <vector>

bool can_append(int n, int k, std::string const& s, std::vector<int> const& x,
                std::vector<int> const& y) {
    if (x.size() == n) return false;
    if (x.size() >= y.size()) return true;
    if ((y[x.size()] < n) ^ (s[k] == 'W')) return false;
    if ((k < n) ^ (s[y[x.size()]] == 'W')) return false;
    return true;
}

bool check_impl(int n, int k, std::string const& s, std::vector<int>& a,
                std::vector<int>& b) {
    if (k == 2 * n) return true;

    if (can_append(n, k, s, a, b)) {
        a.push_back(k);
        if (check_impl(n, k + 1, s, a, b)) {
            return true;
        }
        a.pop_back();
    }

    if (can_append(n, k, s, b, a)) {
        b.push_back(k);
        if (check_impl(n, k + 1, s, a, b)) {
            return true;
        }
        b.pop_back();
    }

    return false;
}

bool check(int n, std::string& s) {
    std::vector<int> a, b;
    return check_impl(n, 0, s, a, b);
}

void solve() {
    int n;
    std::string s;
    std::cin >> n >> s;

    if (check(n, s)) {
        std::cout << "YES" << std::endl;
    } else {
        std::cout << "NO" << std::endl;
    }
}

int main() {
    int t;
    std::cin >> t;

    for (int i = 1; i <= t; ++i) {
        solve();
    }

    return 0;
}
