#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
#define SZ(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()

// Returns the time elapsed in nanoseconds from 1 January 1970, at 00:00:00.
LL get_time() {
    return chrono::duration_cast<chrono::nanoseconds>(
        chrono::steady_clock::now().time_since_epoch())
        .count();
}

// Returns a random integer from the range [l, r].
LL randint(LL l, LL r) {
	#if LOCAL && !ONLINE_JUDGE
	static mt19937_64 gen; // Deterministic on the local machine.
	#else
	static mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
	#endif
	return uniform_int_distribution<LL>(l, r)(gen);
}

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f = nullptr);

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p);

#define _define_print_container(Container, bef, aft)        \
template <typename T>                                       \
ostream& operator <<(ostream& out, const Container<T>& v) { \
    out << print_iterable(v.begin(), v.end(), bef, aft);    \
    return out;                                             \
}                                                           \

_define_print_container(vector, "[", "]");
_define_print_container(set, "{", "}");
_define_print_container(unordered_set, "{", "}");
_define_print_container(multiset, "{", "}");
_define_print_container(unordered_multiset, "{", "}");
_define_print_container(deque, "[", "]");

#define _define_print_dictionary(Dictionary, bef, aft)                      \
template <typename T1, typename T2>                                         \
ostream& operator <<(ostream& out, const Dictionary<T1, T2>& v) {           \
    out << print_iterable(v.begin(), v.end(), bef, aft);                    \
    return out;                                                             \
}                                                                           \

_define_print_dictionary(map, "{", "}");
_define_print_dictionary(unordered_map, "{", "}");

#define _define_print_container_adaptor(Adaptor, OP)                        \
template <typename T>                                                       \
ostream& operator <<(ostream& out, Adaptor<T> a) {                          \
    vector<T> v;                                                            \
    while (!a.empty()) v.push_back(a.OP()), a.pop();                        \
    out << v;                                                               \
    return out;                                                             \
}                                                                           \

_define_print_container_adaptor(stack, top)
_define_print_container_adaptor(queue, front)
_define_print_container_adaptor(priority_queue, top)

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f) {
    stringstream res;
    res << bef;
    bool is_first = true;
    for (Iterator it = begin; it != end; ++it) {
        if (!is_first) res << ", ";
        if (f != nullptr) res << (*f)(*it);
        else res << *it;
        is_first = false;
    }
    res << aft;
    return res.str();
}

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p) {
    out << "{" << p.first << ", " << p.second << "}";
    return out;
}

template<class TH>
void _dbg(const char* name, TH val){
    clog << name << ": " << val << endl;
}
template<class TH, class... TA>
void _dbg(const char* names, TH curr_val, TA... vals) {
    while(*names != ',') clog << *names++;
    clog << ": " << curr_val << ", ";
    _dbg(names+1, vals...);
}

#if LOCAL && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file

    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif

///////////////////////////////////////////////////////////////////////////
//////////////////// DO NOT TOUCH BEFORE THIS LINE ////////////////////////
///////////////////////////////////////////////////////////////////////////

struct pt {
    LL x, y;
    pt(): x(0), y(0) {}
    pt(LL x, LL y): x(x), y(y) {}
};

pt operator +(pt A, pt B) { return {A.x + B.x, A.y + B.y}; }

LL l1dist(pt A, pt B) {
    return llabs(A.x-B.x) + llabs(A.y-B.y);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); // Remove in problems with online queries!
    
    int n;
    cin >> n;
    LL a, b;
    cin >> a >> b;
    vector<LL> d(n-1);
    for (int i = 0; i < n-1; i++) cin >> d[i];
    
    LL sum = 0;
    for (int i = 0; i < n-1; i++) sum += d[i];
    if (((a+b) % 2) != (sum % 2)) {
        cout << "NO\n";
        return 0;
    }
    
    auto dist_error = [&](int pos, pt Z) {
        LL low = 0;
        LL high = 0;
        for (int i = 0; i < pos; i++) {
            high += d[i];
            low = max(low, d[i]);
        }
        low = max(0ll, 2*low - high);
        LL dZ = l1dist(pt(), Z);
        if (dZ < low) return low - dZ;
        if (dZ > high) return dZ - high;
        return 0ll;
    };
    
    
    vector<pt> P(n);
    P[n-1] = {a, b};
    
    if (dist_error(n-1, P[n-1])) {
        cout << "NO\n";
        return 0;
    }
    
    for (int i = n-2; i >= 1; i--) {
        auto cost = [&](pt Z) {
            return dist_error(i, Z) + llabs(l1dist(P[i+1], Z) - d[i]);
        };
        pt Z;
        while (cost(Z) > 0) {
            //~ cout << i << " " << Z.x << " " << Z.y << " " << dist_error(i, Z) << endl;
            LL E = cost(Z);
            pt Q = {randint(-E, E), randint(-E, E)};
            if (cost(Z) > cost(Z+Q))
                Z = Z+Q;
        }
        P[i] = Z;
    }
    
    cout << "YES\n";
    for (int i = 0; i < n; i++) {
        cout << P[i].x << " " << P[i].y << "\n";
    }
}
