// Alice Sayutina 2025

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

using std::optional;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

void solve() {
    int n, m;
    cin >> n >> m;

    const int max_k = 50000;

    vector<pair<int, int>> reqs(m);
    for (int i = 0; i < m; ++i) {
        cin >> reqs[i].first >> reqs[i].second;
        --reqs[i].first, --reqs[i].second;
    }

    std::vector<pair<int, vector<int>>> voters;

    std::mt19937 rnd(31031999);
    for (int iter = 0; iter < int(3 * max_k); ++iter) {
        vector<int> voter(n);
        std::iota(ALL(voter), 0);
        std::shuffle(ALL(voter), rnd);

        vector<int> rev(n, -1);
        for (int i = 0; i < n; ++i) {
            rev[voter[i]] = i;
        }

        int score = 0;
        for (auto [x, y]: reqs) {
            score += (rev[x] < rev[y]);
        }

        voters.emplace_back(score, voter);
        if (voters.size() > 2 * max_k) {
            std::sort(ALL(voters), [&](const auto& a, const auto& b) {return a.first > b.first;});
            voters.resize(max_k);
        }
    }

    if (voters.size() > max_k) {
        std::sort(ALL(voters), [&](const auto& a, const auto& b) {return a.first > b.first;});
        voters.resize(max_k);
    }
    
    cout << "YES\n";
    cout << voters.size() << "\n";
    for (auto [_, voter]: voters) {
        for (int x: voter) {
            cout << 1 + x << " ";
        }
        cout << "\n";
    }
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    for (int t = 1; t <= T; ++t) {
        solve();
    }
    return 0;
}

