#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
#define SZ(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()
 
// Returns the time elapsed in nanoseconds from 1 January 1970, at 00:00:00.
LL get_time() {
    return chrono::duration_cast<chrono::nanoseconds>(
        chrono::steady_clock::now().time_since_epoch())
        .count();
}
 
// Returns a random integer from the range [l, r].
LL randint(LL l, LL r) {
	#if LOCAL && !ONLINE_JUDGE
	static mt19937_64 gen; // Deterministic on the local machine.
	#else
	static mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
	#endif
	return uniform_int_distribution<LL>(l, r)(gen);
}
 
template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f = nullptr);
 
template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p);
 
#define _define_print_container(Container, bef, aft)        \
template <typename T>                                       \
ostream& operator <<(ostream& out, const Container<T>& v) { \
    out << print_iterable(v.begin(), v.end(), bef, aft);    \
    return out;                                             \
}                                                           \
 
_define_print_container(vector, "[", "]");
_define_print_container(set, "{", "}");
_define_print_container(unordered_set, "{", "}");
_define_print_container(multiset, "{", "}");
_define_print_container(unordered_multiset, "{", "}");
_define_print_container(deque, "[", "]");
 
#define _define_print_dictionary(Dictionary, bef, aft)                      \
template <typename T1, typename T2>                                         \
ostream& operator <<(ostream& out, const Dictionary<T1, T2>& v) {           \
    out << print_iterable(v.begin(), v.end(), bef, aft);                    \
    return out;                                                             \
}                                                                           \
 
_define_print_dictionary(map, "{", "}");
_define_print_dictionary(unordered_map, "{", "}");
 
#define _define_print_container_adaptor(Adaptor, OP)                        \
template <typename T>                                                       \
ostream& operator <<(ostream& out, Adaptor<T> a) {                          \
    vector<T> v;                                                            \
    while (!a.empty()) v.push_back(a.OP()), a.pop();                        \
    out << v;                                                               \
    return out;                                                             \
}                                                                           \
 
_define_print_container_adaptor(stack, top)
_define_print_container_adaptor(queue, front)
_define_print_container_adaptor(priority_queue, top)
 
template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f) {
    stringstream res;
    res << bef;
    bool is_first = true;
    for (Iterator it = begin; it != end; ++it) {
        if (!is_first) res << ", ";
        if (f != nullptr) res << (*f)(*it);
        else res << *it;
        is_first = false;
    }
    res << aft;
    return res.str();
}
 
template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p) {
    out << "{" << p.first << ", " << p.second << "}";
    return out;
}
 
template<class TH>
void _dbg(const char* name, TH val){
    clog << name << ": " << val << endl;
}
template<class TH, class... TA>
void _dbg(const char* names, TH curr_val, TA... vals) {
    while(*names != ',') clog << *names++;
    clog << ": " << curr_val << ", ";
    _dbg(names+1, vals...);
}
 
#if LOCAL && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file
 
    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif
 
///////////////////////////////////////////////////////////////////////////
//////////////////// DO NOT TOUCH BEFORE THIS LINE ////////////////////////
///////////////////////////////////////////////////////////////////////////
 
struct Dsu {
  public:
    Dsu(int set_size) :
        ancestor(set_size),
        sizes(set_size),
        pq(set_size),
        groups_number(set_size) {
        for (int i = 0; i < set_size; i++) {
            ancestor[i] = i;
            sizes[i] = 1;
        }
    }
  
    // Join the groups containing a and b.
    void Join(int a, int b) {
        a = WhichGroup_(a);
        b = WhichGroup_(b);
        if (a == b) {
            // Already in the same group
            return;
        }
        if (sizes[a] > sizes[b]) {
            // After this we can assume sizes[a] <= sizes[b]
            swap(a, b);
        }
        // Joining a in b
        sizes[b] += sizes[a];
        ancestor[a] = b;
        
        if (ssize(pq[a]) > ssize(pq[b]))
            swap(pq[a], pq[b]);
        while (!pq[a].empty()) {
            pq[b].push(pq[a].top());
            pq[a].pop();
        }
        
        groups_number--;
    }
 
    // Whether a and b are in the same group.
    bool SameGroup(int a, int b) const {
        return WhichGroup_(a) == WhichGroup_(b);
    }
 
    // The representative of the group to which a belongs.
    int GetRepresentative(int a) const {
        return WhichGroup_(a);
    }
 
    // The size of the group that contains a.
    int GroupSize(int a) const {
        return sizes[WhichGroup_(a)];
    }
 
    // The number of groups.
    int GroupsNumber() const {
        return groups_number;
    }
 
    mutable vector<int> ancestor; // Not always the root of the group.
    vector<int> sizes; // This is correct only for indexes that are roots.
    vector<priority_queue<pair<int,int>>> pq;
    int groups_number;
 
    int WhichGroup_(int a) const {
        if (ancestor[a] != a) {
            ancestor[a] = WhichGroup_(ancestor[a]);
        }
        return ancestor[a];
    }
};
 
 
const int INF = 1<<25;
 
// aa contains only edges (layer k) -> (layer k-1)
vector<int> subproblem(int n, vector<vector<int>> aa, vector<int> layer) {
    assert(ssize(aa) == n);
    assert(ssize(layer) == n);
    
    //~ cout << n << " " << aa << " " << layer << endl;
    
    vector<int> ord(n);
    for (int i = 0; i < n; i++) ord[i] = i;
    sort(all(ord), [&](int x, int y) { return layer[x] < layer[y]; });
    
    const int E = 20;
    vector<vector<int>> f(E, vector(n+1, n));
    vector<int> depth(n, 0);
    
    auto lca = [&](int u, int v) {
        if (depth[u] < depth[v]) swap(u, v);
        for (int e = E-1; e >= 0; e--) 
            if (depth[u] - (1<<e) >= depth[v]) u = f[e][u];
        // Same depth now
        if (u == v) return u;
        for (int e = E-1; e >= 0; e--)
            if (f[e][u] != f[e][v]) u = f[e][u], v = f[e][v];
        return f[0][u];
    };
    
    for (int v: ord) {
        if (aa[v].empty()) continue;
        int x = aa[v][0];
        for (int a: aa[v]) x = lca(x, a);
        f[0][v] = x;
        for (int e = 1; e < E; e++) f[e][v] = f[e-1][f[e-1][v]];
        depth[v] = 1 + depth[f[0][v]];
    }
    //~ cout << "f: " << endl;
    //~ for (int v = 0; v < n; v++) {
        //~ cout << v << ": " << f[0][v] << endl;
    //~ }
    //~ cout << endl;
    
    vector<vector<int>> to_append(n+1);
    for (int i = 0; i < n; i++) to_append[f[0][i]].push_back(i);
    vector<vector<int>> boundary(n);
    for (int v = 0; v < n; v++) for (int a: aa[v])
        boundary[a].push_back(v);
    
    
    Dsu dsu(n);
    vector<bool> valid(n, true);
    
    sort(all(ord), [&](int x, int y) { return layer[x] > layer[y]; });
    
    vector<int> ans(n, INF);
    for (int v: ord) {
        for (int a: boundary[v]) dsu.pq[v].push({-layer[a], a});
        for (int a: to_append[v]) {
            dsu.Join(a, v);
            valid[a] = false;
        }
        int r = dsu.GetRepresentative(v);
        auto& Z = dsu.pq[r];
        while (!Z.empty() and !valid[Z.top().second]) Z.pop();
        if (!Z.empty()) ans[v] = layer[Z.top().second] - layer[v];
    }
    
    return ans;
}
 
vector<int> bfs(int n, vector<vector<int>> aa, int source) {
    queue<int> q;
    vector<int> dist(n, INF);
    dist[source] = 0;
    q.push(source);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int a: aa[v]) {
            if (dist[a] > dist[v] + 1) {
                dist[a] = dist[v] + 1;
                q.push(a);
            }
        }
    }
    return dist;
}
 
void solve(int n, vector<vector<int>> aa) {
    vector<int> dist = bfs(n, aa, n-1);
    
    // Constructing the even subproblem.
    vector<vector<int>> aa_even(n);
    vector<int> layer_even(n);
    for (int v = 0; v < n; v++) {
        layer_even[v] = dist[v];
        for (int a: aa[v]) if (dist[a] + 1 == dist[v]) {
            aa_even[v].push_back(a);
        }
    }
    
    // Constructing the odd subproblem.
    Dsu dsu_odd(n);
    for (int v = 0; v < n; v++) {
        for (int a: aa[v]) if (dist[a] == dist[v]) dsu_odd.Join(v, a);
    }
    int m = dsu_odd.GroupsNumber();
    vector<int> odd_label(n);
    set<int> representative;
    for (int v = 0; v < n; v++) 
        representative.insert(dsu_odd.GetRepresentative(v));
    int id = 0;
    for (int r: representative) {
        odd_label[r] = id;
        id++;
    }
    assert(id == m);
    for (int v = 0; v < n; v++) odd_label[v] = odd_label[dsu_odd.GetRepresentative(v)];
    
    vector<vector<int>> aa_odd(m);
    set<pair<int,int>> odd_edges;
    for (int v = 0; v < n; v++) {
        for (int a: aa[v]) {
            if (dist[a] + 1 != dist[v]) continue;
            int x = odd_label[v];
            int y = odd_label[a];
            if (odd_edges.count({x, y})) continue;
            odd_edges.insert({x, y});
            aa_odd[x].push_back(y);
        }
    }
    vector<int> layer_odd(m, INF);
    for (int v = 0; v < n; v++) layer_odd[odd_label[v]] = dist[v];
    
    
    // Solve the subproblems.
    vector<int> ans_even = subproblem(n, aa_even, layer_even);
    vector<int> ans_odd = subproblem(m, aa_odd, layer_odd);
    ans_even.resize(300000, 1e8);
    ans_even.assign(300000, 1e8);
    
    // Computing g[v] from the answers to the subproblems.
    // g[v] = The minimum distance from v to n if the first edge on
    //        a shortest path from v to n is deleted.
    vector<int> g(n, 0);
    for (int v = 0; v < n; v++) {
        if (aa_even[v].size() > 1) g[v] = dist[v];
        else if (dsu_odd.GroupSize(v) > 1) g[v] = 1 + dist[v];
        else {
            g[v] = min(2*ans_even[v], 2*ans_odd[odd_label[v]] + 1);
            g[v] += dist[v];
        }
    }
    
    // Answer if we are currently in node v.
    // ans[0] is the answer to the problem.
    //
    // ans[v] = max(dist[v], 1 + min_a ans[a])
    // Compute it using Dijkstra starting from n-1.
    vector<int> ans(n, INF);
    ans[n-1] = 0;
    priority_queue<pair<int,int>> pq;
    pq.push({0, n-1});
    while (!pq.empty()) {
        auto pp = pq.top();
        pq.pop();
        int v = pp.second;
        int d = -pp.first;
        if (ans[v] < d) continue;
        for (int a: aa[v]) {
            int new_d = max(g[a], 1 + d);
            if (new_d >= ans[a]) continue;
            ans[a] = new_d;
            pq.push({-ans[a], a});
        }
    }
    
    int cost_1 = ans[0];
    if (cost_1 > 3*n) cout << -1 << "\n";
    else cout << ans[0] << "\n";
    
    //for (int v = 0; v < n; v++) cout << v << ": " << ((g[v] >= INF)? int(1e9) : g[v]) << endl;
}
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); // Remove in problems with online queries!
 
    int n, m;
    cin >> n >> m;
    vector<vector<int>> aa(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        aa[x].push_back(y);
        aa[y].push_back(x);
    }
    
    solve(n, aa);
}
