#include <bits/stdc++.h>

using namespace std;
typedef pair<int, int> pii;
#define S second
#define F first
#define MAXN 200005

vector<vector<int>> adj;
int f[MAXN], g[MAXN];
int n, m, s, t;
int vis[MAXN], dis[MAXN], ideg[MAXN];
int bedge[MAXN];

const int INF = 1e9;

void bfs(int st) {
  queue<pii> q;
  q.push(pii(0, st));
  vis[st] = 1;
  while (!q.empty()) {
    pii nx = q.front();
    q.pop();
    dis[nx.S] = nx.F;

    for (int v : adj[nx.S]) {
      if (vis[v]) continue;
      vis[v] = 1;
      q.push(pii(nx.F + 1, v));
    }
  }
}

void calc_g() {
  for (int i = 0; i < n; i++) {
    g[i] = INF;
    vis[i] = 0;
    ideg[i] = 0;
  }
  
  bfs(t);
  
  for (int v = 0; v < n; v++)
    for (int u : adj[v])
      if (dis[v] == dis[u] + 1) {
	bedge[v] = u;
	ideg[u]++;
	break;
      }

  queue<int> free_nodes;
  for (int v = 0; v < n; v++)
    if (ideg[v] == 0)
      free_nodes.push(v);

  while (!free_nodes.empty()) {
    int nx = free_nodes.front();
    free_nodes.pop();

    for (int u : adj[nx]) {
      if (bedge[nx] != u) {
	if (bedge[u] != nx)
	  g[nx] = min(g[nx], 1 + dis[u]);
	else
	  g[nx] = min(g[nx], 1 + g[u]);
      }
      else {
	ideg[u]--;
	if (ideg[u] == 0)
	  free_nodes.push(u);
      }
    }
  }
}

void calc_f() {
  for (int i = 0; i < n; i++) {
    f[i] = INF;
    vis[i] = 0;
  }

  std::priority_queue<pii, std::vector<pii>, std::greater<pii>> pq;
  pq.push(pii(0, t));
  while (!pq.empty()) {
    pii nx = pq.top();
    pq.pop();

    if (vis[nx.S])
      continue;
    vis[nx.S] = 1;

    if (nx.S != t) {
      f[nx.S] = INF;
      for (int v : adj[nx.S])
	f[nx.S] = min(f[nx.S], 1 + f[v]);
      f[nx.S] = max(f[nx.S], g[nx.S]);
    }
    else
      f[nx.S] = 0;

    for (int v : adj[nx.S])
      pq.push(pii(f[nx.S], v));

    if (nx.S == s)
      return;
  }
}

int calc_ans() {
  calc_g();
  calc_f();
  return f[s];
}

int main() {
  // Read input
  cin >> n >> m;
  s = 0;
  t = n - 1;
    
  adj.assign(n + 1, vector<int>());
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    u--; v--;
    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  int result = calc_ans();
  if (result < INF)
    cout << result << endl;
  else
    cout << -1 << endl;

  // cout << g[0] << endl;
  // cout << g[1] << endl;
  // cout << g[2] << endl;
  // cout << g[3] << endl;
  // cout << g[4] << endl;

  return 0;
}

