#include <bits/stdc++.h>
using namespace std;

#if LOCAL && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file

    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif

const int MAX_N = 20;
const int SZ = 1000;
const int MAX_DIST = 5'000'000;

int n;
int h[MAX_N][MAX_N];
int distances[2 * SZ + 1][2 * SZ + 1];
vector<pair<int,int>> bfs_q[MAX_DIST];

void reset_arrays() {
    for (int i = 0; i < 2 * SZ + 1; ++i)
        for (int j = 0; j < 2 * SZ + 1; ++j)
            distances[i][j] = MAX_DIST;

    for (int d = 0; d < MAX_DIST; d++) 
        bfs_q[d].clear();
}

// Directions for moving in the grid
int dx[4] = {1, -1, 0, 0};
int dy[4] = {0, 0, 1, -1};

double bfs() {
    reset_arrays();
    
    int x0 = SZ, y0 = SZ;
    bfs_q[0].push_back({x0, y0});
    distances[x0][y0] = 0;
    
    int cnt = 0;
    int max_d = MAX_DIST;
    for (int d = 0; d < max_d; d++) {
        for (const auto& [x, y]: bfs_q[d]) {
            if (distances[x][y] < d) continue;
            cnt++;
            
            for (int _ = 0; _ < 4; _++) {
                int x2 = x + dx[_], y2 = y + dy[_];
                int d2 = d + 1 + abs(h[x%n][y%n] - h[x2%n][y2%n]);
                if (x2 < 0 or x2 > 2*SZ or y2 < 0 or y2 > 2*SZ) {
                    max_d = min(max_d, d2);
                } else if (distances[x2][y2] > d2) {
                    distances[x2][y2] = d2;
                    bfs_q[d2].push_back({x2, y2});
                }
            }
        }
        bfs_q[d].clear();
    }
    
    // There are cnt cells at distance <= cnt.
    double d = max_d-1;
    //~ cout << d << " " << cnt << endl;
    return ((double)cnt) / (d*d);
}

int main() {
    cin >> n;

    for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) 
        cin >> h[i][j];
    
    reset_arrays();
    double area = bfs();

    double R = 1e20;
    cout.precision(10);
    cout << area * R*R << endl;
}
