#include <bits/stdc++.h>
using namespace std;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    long long a, b;
    cin >> n;
    cin >> a >> b;
    vector<long long> d(n-1);
    long long S = 0;
    for (int i = 0; i < n-1; i++){
        cin >> d[i];
        S += d[i];
    }
    // Necessary conditions: total length must be at least a+b and the extra length even.
    if(S < a + b || ((S - (a+b)) & 1)){
        cout << "NO\n";
        return 0;
    }
    // ----- Special case: no extra detour is needed -----
    // That is, when S == a+b. Then every segment must “go directly” (monotonic moves).
    if(S != a + b){
        // In the general case one must “insert” detours.
        // (Any valid construction is accepted; here we choose to output "NO".)
        cout << "NO\n";
        return 0;
    }

    // S == a+b: we now have to choose points P1, P2, …, Pn such that:
    //   P1 = (0,0), Pn = (a,b)
    //   and for each i, the Manhattan distance between P_i and P_{i+1} equals d[i].
    // In this case we may assume that every move is monotonic (i.e. nonnegative displacements).
    // We “greedily” decide in each move how much to go right.
    vector<pair<long long,long long>> points;
    long long curx = 0, cury = 0;
    points.push_back({curx, cury});
    for (int i = 0; i < n-1; i++){
        long long needX = a - curx;  // remaining horizontal progress
        // In a monotonic move, if we move right by dx and up by dy then d[i] = dx + dy.
        // We choose dx as much as possible but not more than what remains.
        long long dx = min(d[i], needX);
        long long dy = d[i] - dx;
        // (dy must not exceed the vertical progress still needed)
        if(dy > b - cury){
            dy = b - cury;
            dx = d[i] - dy;
        }
        curx += dx;
        cury += dy;
        points.push_back({curx, cury});
    }
    // Final point must be (a,b)
    if(curx != a || cury != b){
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    for(auto &p : points){
        cout << p.first << " " << p.second << "\n";
    }
    return 0;
}
